//
//////////////////////////////////////////////////////////////////////////////////
// Copyright  2010, Xilinx, Inc.
// This file contains confidential and proprietary information of Xilinx, Inc. and is
// protected under U.S. and international copyright and other intellectual property laws.
//////////////////////////////////////////////////////////////////////////////////
//
// Disclaimer:
// This disclaimer is not a license and does not grant any rights to the materials
// distributed herewith. Except as otherwise provided in a valid license issued to
// you by Xilinx, and to the maximum extent permitted by applicable law: (1) THESE
// MATERIALS ARE MADE AVAILABLE "AS IS" AND WITH ALL FAULTS, AND XILINX HEREBY
// DISCLAIMS ALL WARRANTIES AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY,
// INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT,
// OR FITNESS FOR ANY PARTICULAR PURPOSE; and (2) Xilinx shall not be liable
// (whether in contract or tort, including negligence, or under any other theory
// of liability) for any loss or damage of any kind or nature related to, arising
// under or in connection with these materials, including for any direct, or any
// indirect, special, incidental, or consequential loss or damage (including loss
// of data, profits, goodwill, or any type of loss or damage suffered as a result
// of any action brought by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the possibility of the same.
//
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-safe, or for use in any
// application requiring fail-safe performance, such as life-support or safety
// devices or systems, Class III medical devices, nuclear facilities, applications
// related to the deployment of airbags, or any other applications that could lead
// to death, personal injury, or severe property or environmental damage
// (individually and collectively, "Critical Applications"). Customer assumes the
// sole risk and liability of any use of Xilinx products in Critical Applications,
// subject only to applicable laws and regulations governing limitations on product
// liability.
//
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS PART OF THIS FILE AT ALL TIMES.
//
//////////////////////////////////////////////////////////////////////////////////
//
// Definition of a single port ROM for KCPSM3 program defined by uclock.psm
//
// Generated by KCPSM3 Assembler 25Sep2010-14:48:36. 
//
//////////////////////////////////////////////////////////////////////////////////
//
//
`timescale 1 ps / 1ps
//
module uclock (
input   [9:0] address,
input         clk,
output [17:0] instruction );
//
RAMB16_S18  #(
      .INIT_00(256'h0D0000A4E00CE00BE00AE009E008E007E006E005E004E003E002E001E0000000),
      .INIT_01(256'h40490091501200ED50374041501E40545012400D0091012000C30115C0010C00), 
      .INIT_02(256'h5812006D541C4020401200A8542C400D0091541C40450091541C404D0091541C), 
      .INIT_03(256'h541C40520091541C40410091541C404C0091401200A8E005E004E408E507E606), 
      .INIT_04(256'h5812006DC1015055404F0091541C4020401200AC5448400D0091541C404D0091), 
      .INIT_05(256'h401200ACE00CC002600C541C400D00915460404E0091401200ACE40BE50AE609), 
      .INIT_06(256'h1620588B01EC401200AC00A4E00C0000541C400D0091541C40460091541C4046), 
      .INIT_07(256'h009181011420588B01EC548B403A009181011520588B01EC548B403A00918101), 
      .INIT_08(256'h000E0001013400E70125A000000E00005C8B443C5C8B453C5C8B4618548B400D), 
      .INIT_09(256'h50A220024000A000009D4F0140950185549A20104000A000810101E27010A000), 
      .INIT_0A(256'h013D00BC01600E09A00000BC01600E06A000C000A001600CA000CF01409D0185), 
      .INIT_0B(256'h4F0D009D7F100120A0000148A000014E50BA2002A000015350B62001600C00E7), 
      .INIT_0C(256'h810150D34F08B0004F0DFF10009554DB2008400082101210012040BD8101B000), 
      .INIT_0D(256'h400000E400FAEF2000E440C3012240C600EA00E758D94120C10100EA54C65120), 
      .INIT_0E(256'h0F79009D0F53A000009D0F08A000009D0F20A000009D0F0D40DF4F01B0002010), 
      .INIT_0F(256'h009D0F65009D0F76009D0F4F410A009D0F78009D0F61009D0F74009D0F6E009D), 
      .INIT_10(256'h009D009D0F72009D0F4500E7009D0F77009D0F6F009D0F6C009D0F66009D0F72), 
      .INIT_11(256'h009D0F4D009D0F53009D0F50009D0F43009D0F4B00E4A000009D0F72009D0F6F), 
      .INIT_12(256'h0F69009D0F6C009D0F61009D0F76009D0F6E009D0F49A000009D0F3E009D0F33), 
      .INIT_13(256'h0F6C009D0F41A000009D0F65009D0F6D009D0F69009D0F54A000009D0F64009D), 
      .INIT_14(256'h009D0F4FA000009D009D0F46009D0F4FA000009D0F6D009D0F72009D0F61009D), 
      .INIT_15(256'hA000009D0F65009D0F76009D0F69009D0F74009D0F63009D0F41A000009D0F4E), 
      .INIT_16(256'hF0208201F120017E70E08E018201F020003A8201F0208201F120017E70E00220), 
      .INIT_17(256'h81010130A000F020000D8201F0208201F120017E70E08E018201F020003A8201), 
      .INIT_18(256'hEC01ED00C00063016200E515E414E313E212E111E010A000803AC1015D7FC00A), 
      .INIT_19(256'h82E8419A8001599FE303C2E80000B350924063036202F530D42065016400C001), 
      .INIT_1A(256'hE204A30382E841AF800159ADE303C2E80000A300920063056204E303E202A303), 
      .INIT_1B(256'h010041C9E10751BF413C81016107E108010041C9E10851B7413C91006108E305), 
      .INIT_1C(256'h5010610A600755DB501061096006E106010041C9E10651C7411881016106E107), 
      .INIT_1D(256'h6414631362126111601000A4E00CC00151DB2002600C55DB5010610B600855DB), 
      .INIT_1E(256'h1200B80001E87010A000C0F6B80080C6A000A0DFBC00407BB8004061A0006515), 
      .INIT_1F(256'h000000000000000000000000A0009200B80001E8701081010206920002060206), 
      .INIT_20(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_21(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_22(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_23(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_24(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_25(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_26(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_27(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_28(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_29(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_2A(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_2B(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_2C(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_2D(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_2E(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_2F(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_30(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_31(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_32(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_33(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_34(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_35(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_36(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_37(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_38(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_39(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_3A(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_3B(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_3C(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_3D(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_3E(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INIT_3F(256'h43FC8001AC008D01000000000000000000000000000000000000000000000000),
      .INITP_00(256'hD3F74FDD3FF8DF7DF837DFEAF77DFDF7DF7DFEAAFDFDF7DF7FDDDCFC3AAAAAA8),
      .INITP_01(256'hCCCF333332CB2CC93EFFFD7D766F443670BBDBD3FCBCA0AFD2CFD2728FE8DDDD),
      .INITP_02(256'h4A19B1619B1619B0B333332CCBCCB33332CCCCB3333332CCCCCCCECCF33CCCCC), 
      .INITP_03(256'h0009B19A2C9989980038D34343423B523B523B529775142977514143AC2AAA5D), 
      .INITP_04(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INITP_05(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INITP_06(256'h0000000000000000000000000000000000000000000000000000000000000000), 
      .INITP_07(256'hF500000000000000000000000000000000000000000000000000000000000000))
ram_1024_x_18(
      .DI         (16'h0000),
      .DIP        (2'b00),
      .EN         (1'b1),
      .WE         (1'b0),
      .SSR        (1'b0),
      .CLK        (clk),
      .ADDR       (address),
      .DO         (instruction[15:0]),
      .DOP        (instruction[17:16])) ;
//
endmodule
//
//////////////////////////////////////////////////////////////////////////////////
//
// END OF FILE uclock.v
//
//////////////////////////////////////////////////////////////////////////////////
//
