// --=========================================================================--
//  This confidential and proprietary software may be used only as
//  authorised by a licensing agreement from CAS LAB, NCKU Limited
//    (C) COPYRIGHT 2005 Computer and System LAB, NCKU Limited
//        ALL RIGHTS RESERVED
//  The entire notice above must be reproduced on all authorised
//  copies and copies may only be made to the extent permitted
//  by a licensing agreement from CAS LAB, NCKU Limited.
// 
// -----------------------------------------------------------------------------
// Version and Release Control Information:
// 
// File Name : Write_Buffer_Data_unit.v,v
// File Revision : 1.1
// 
// Release Information : 
// 
// -----------------------------------------------------------------------------
// Description         : 
// -----------------------------------------------------------------------------
// Revision History    : Revision 1.0  2005/06/08 15:11 Wei-Sheng Lu
//  			 Initial revision
// 			 Revision 1.1  2007/05/18 08:21 Tai-Hua Lu
//			 The clock triggers change form negative-edge to positive-edge.
// --=========================================================================--

module Write_Buffer_Data_unit(
	// Signals used during normal operation 
	clk,
	
	// Signals from Outgoing Controller used during normal operation
	RAddr,
	OE,
	RData,
	
	// Signals from Income Controller used during normal operation
	WAddr,
	WE,
	WData
);
// Signals used during normal operation 
input		clk;

// Signals from Outgoing Controller used during normal operation
input	[1:0]	RAddr;
input		OE;
output	[127:0]	RData;

// Signals from Income Controller used during normal operation
input	[1:0]	WAddr;
input		WE;
input	[127:0]	WData;

wire  WWEn;
wire  WOEn;

//----------------------------------------------------------------------
// Beginning of main code
//----------------------------------------------------------------------

assign WWEn=~WE;
assign WOEn=~OE;

Write_Buffer_DataRAM uWrite_Buffer_DataRAM	(
		.clk	(clk),
		.RA	(RAddr[1:0]), 
		.WA	(WAddr[1:0]), 
		.CSn	(1'b0), 
		.WEn	(WWEn), 
		.OEn	(WOEn), 
		.DI	(WData), 
		.DO	(RData)
		);
endmodule